UNAME_P=$(shell uname -p)

ifeq ("$(ARCH)", "")
    ifeq ("$(UNAME_P)", "i386")
        ARCH=x86
    else ifeq ("$(UNAME_P)", "x86_64")
        ARCH=x64
    else
        $(info Failed to check the OS architecture with the shell command `uname`. The ARCH will be set to x64.)
        $(info Please run the command `ARCH=[your input] make` to manually set the system ARCH.)
        ARCH=x64
    endif
endif

ifeq ("$(ARCH)", "x86")
    CFLAGS+= -m32
endif


ifndef IOTC_ROOT_DIR
    $(error IOTC_ROOT_DIR is not set)
endif
IOTC_LIB_PATH=$(IOTC_ROOT_DIR)/Lib/Linux/$(ARCH)
IOTC_INC_PATH=$(IOTC_ROOT_DIR)/Include

CFLAGS+= -I$(IOTC_INC_PATH)
LDFLAGS+= -L$(IOTC_LIB_PATH)
ifneq ("$(LINK)", "static")
    LDFLAGS+= -Wl,-rpath=$(IOTC_LIB_PATH) -Wl,--disable-new-dtags
else
    TUTK_DEBUG_LIBS=$(wildcard $(IOTC_LIB_PATH)/*T.a)
    TUTK_RELEASE_LIBS=$(patsubst %T.a,%.a,$(TUTK_DEBUG_LIBS))
    TUTK_3RDPARTY_LIBS=$(filter-out $(TUTK_DEBUG_LIBS) $(TUTK_RELEASE_LIBS),$(wildcard $(IOTC_LIB_PATH)/*.a))
    LDFLAGS+= -Wl,--start-group $(TUTK_3RDPARTY_LIBS) -Wl,--end-group
endif
LDFLAGS+= -lpthread
